#!/bin/bash

if [ $# = 0 ]; then
	echo "USAGE: get_workdir.sh config_file"
	exit 1
fi


conf=$1

if [ "$uid" = "" ] ; then
	uid=$$ 
fi

# load configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

if [ ! -x $conf ] ; then
	echo "ERROR: The configuration file was not found - $conf"
	exit 1
fi
if [ ! -x $conf_global ] ; then
	echo "ERROR: The global configuration file was not found - $conf_global"
	exit 1
fi

source $conf_global
source $conf

uid=$RANDOM
loc_tmp_dir="$tmp_dir/$uid"                                                    # /tmp/$user/$process_id
while [ -e $loc_tmp_dir ] ; do 
	uid=$RANDOM
	loc_tmp_dir="$tmp_dir/$uid"
done           

# check temp
work_dir=$out_dir
if [ $use_tmp == 1 ] ; then
	loc_tmp_dir="$tmp_dir/$uid"                                            # /tmp/$user/$process_id
	mkdir -p $loc_tmp_dir
	free_space=`df $loc_tmp_dir | tail -n 1 | awk '{print int($4/1024)}'`  # in MB
	if [ $free_space -ge $tmp_min_space ] ; then
		work_dir=$loc_tmp_dir                                          # there is not enough space in the tmp
	else
		rm -r -f $loc_tmp_dir
		if [ "`ls $tmp_dir`" == "" ] ; then   # remove /tmp/$USER if the directory is not used by other processes 
			rmdir $tmp_dir
		fi
	fi
fi

echo $work_dir
