#!/usr/bin/perl

# This scripts converts HTK model file for using by SVite with precalculated likelihoods
#
# phn_num_list ~ two column list - index, phomeme

if($ARGV[0] eq "" || $ARGV[1] eq "")
{
	print "SYNTAX: gmm2like.pl hmmdef phn_num_list\n";
	exit(1);
}

#load phoneme list

open L, $ARGV[1] or die "Can not open $ARGV[1]";

$max = 0;
while($l = <L>)
{
	chomp $l;
	($num, $phn) = split /\s+/, $l;
	$indexes{$phn} = $num;
	$max = $num if($max < $num);
}
$npdfs = $max + 1;

close L;


#process the MLF
open H, $ARGV[0] or die "Can not open $ARGV[0]";

while($l = <H>)
{
	chomp $l;
	if($l =~ /~o/)
	{

		while(not ($l =~ /~h/))
		{
			$l = <H>;
			chomp $l;
		}
		print "~o <VecSize> $npdfs <PDFObsVec>\n"
	}
	if($l =~ /~h \"(.+)\"/)
	{
		$modelname = $1;
	}
	if($l =~ "<STATE> 2")
	{
		$n = $indexes{$modelname} + 1;
		die "Phoneme $modelname does not exists in the list" if($n eq "");
		print "<STATE> 2 <ObsCoef> $n\n";
		while(not ($l =~ /<TRANSP>/))
		{
			$l = <H>;
			chomp $l;
			print "<STATE> $1 <ObsCoef> $n\n" if($l =~ /<STATE> ([0-9]+)/);
		}
	}


	print "$l\n";
}

close H;



