#!/bin/bash

if [ $# -lt 2 ]; then
	echo "USAGE: rm_workdir.sh config_file work_dir"
	exit 1
fi


conf=$1
work_dir=$2

# load configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

if [ ! -x $conf ] ; then
        echo "ERROR: The configuration file was not found - $conf"
        exit 1
fi
if [ ! -x $conf_global ] ; then
        echo "ERROR: The global configuration file was not found - $conf_global"
        exit 1
fi

source $conf_global
source $conf

if [ "$use_tmp" = "1" ] && [ $work_dir != $out_dir ]; then
        rm -r -f $work_dir
        if [ "`ls $tmp_dir`" == "" ] ; then   # remove /tmp/$USER if the directory is not used by other process
                rmdir $tmp_dir
        fi
fi
