#!/usr/bin/perl

# This script modifies normalization file for QuickNet

if($ARGV[0] eq "" || $ARGV[1] eq "" || $ARGV[2] eq "")
{
	print "USAGE: weight_norms.pl weight_file window_type{hamming,triang,discrete} num_of_windows [discrete_vaues_file]\n";
	exit(1);
}

$input = $ARGV[0];
$wtype = $ARGV[1];
$num_winds = $ARGV[2];
$disc_file = $ARGV[3];

# load the file
open IN, $input or die "Can not open the input file: $input";

$vec = <IN>;
$vec =~ /vec ([0-9]+)/;
$vect_size = $1;

@mean = ();

for($i = 0; $i < $vect_size; $i++)
{
	$v = <IN>;
	chomp $v;
	push @mean, $v;
}

$vec = <IN>;
$vec =~ /vec ([0-9]+)/;
$vect_size = $1;

@var = ();

for($i = 0; $i < $vect_size; $i++)
{
	$v = <IN>;
	chomp $v;
	push @var, $v;
}

close IN; 

# generate the window
$window_len = $vect_size / $num_winds;
        
if($wtype eq "hamming")
{
	for ($i = 0; $i < $window_len; $i++)
	{
		$win[$i] = 0.54 - 0.46 * cos(2.0 * 3.1415926535897932 * $i / ($window_len - 1));
	}
}
elsif($wtype eq "triang")
{
	$window_len_2 = int($window_len / 2);
	$start_val = 1 / $window_len;
	$delta = 1 / ($window_len / 2);
	
	$v = $start_val;
	$j = 0;
	for($i = 0; $i < $window_len_2; $i++)
	{
		$win[$j] = $v;
		$j++;
		$v += $delta;
	}
	$k = $j - 1;
	if($window_len % 2 == 1)
	{
		$win[$j] = 1;
		$j++;
	}
	for($i = 0; $i < $window_len_2; $i++)
	{
		$win[$j] = $win[$k];
		$j++;
		$k--;
	}
}
elsif($wtype eq "discrete")
{
	#print STDERR "ERROR: weight_norms.pl - discrete window is not implemented yet";
	open DF, "$disc_file" or die "ERROR: Can not load the discrete window: $disc_file";
	if(not $l = <DF>)
	{
	     die "ERROR: The file does not contain the window: $disc_file";
	}
	$l =~ s/^ +//;
	$l =~ s/ $//;
	@win = split /\s+/, $l;
	$n1 = @win;
	die "ERROR: Invalid discrete window length: l-win $n1, l-norms $window_len" if(@win != $window_len);
	close DF;
}
else
{
	print STDERR "ERROR: weight_norms.pl - invalid window\n";
	exit 1;
}

# copy the window $num_winds times
@win_full = ();
for($i = 0; $i < $num_winds; $i++)
{
	push @win_full, @win;
}

# scale the vector of variances (standard diversions)
for($i = 0; $i < @var; $i++)
{
	$var[$i] *= $win_full[$i];
}

$n = @mean;
print "vec $n\n";
for($i = 0; $i < $n; $i++)
{
	print "$mean[$i]\n";
}

$n = @var;
print "vec $n\n";
for($i = 0; $i < $n; $i++)
{
	print "$var[$i]\n";
}


